function distance(lat1, lon1, lat2, lon2, unit) {
	if ((lat1 == lat2) && (lon1 == lon2)) {
		return 0;
	} else {
		var radlat1 = Math.PI * lat1/180;
		var radlat2 = Math.PI * lat2/180;
		var theta = lon1-lon2;
		var radtheta = Math.PI * theta/180;
		var dist = Math.sin(radlat1) * Math.sin(radlat2) + Math.cos(radlat1) * Math.cos(radlat2) * Math.cos(radtheta);
		if (dist > 1) {dist = 1};
		dist = Math.acos(dist);
		dist = dist * 180/Math.PI;
		dist = dist * 60 * 1.1515; 					// miles (def)
		if (unit=="K") { dist = dist * 1.609344 } 	// km
		if (unit=="F") { dist = dist * 5280 }		// feet
		return dist;
	}
}

class HourMeter extends BaseInstrument {
    constructor() {
        super();
		this.state = "flying";
		this.vspeed = 0;
		this.landLat = 0;
		this.landLon = 0;
		this.dist = 0;
    }
    get templateID() { return "HourMeter"; }
    connectedCallback() {
        super.connectedCallback();
        this.lmode = this.getChildById("Lmode");
        this.lvalu = this.getChildById("Lvalu");
        this.lunit = this.getChildById("Lunit");

        this.rmode = this.getChildById("Rmode");
        this.rvalu = this.getChildById("Rvalu");
        this.runit = this.getChildById("Runit");

		this.lunit.innerHTML = "ft";
		this.rmode.innerHTML = "V<br>S<br>P<br>D";
		this.runit.innerHTML = "ft/sec";
	
		if (typeof g_modDebugMgr != "undefined") {g_modDebugMgr.AddConsole(null)}; // if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};
    }
    disconnectedCallback() {
        super.disconnectedCallback();
    }
    Update() {
        super.Update();

		let alt = SimVar.GetSimVarValue("PLANE ALT ABOVE GROUND", "feet").toFixed(0);
		if (alt>50) {
			this.state = "flying"
		};
		if (alt<1000) {
			if (alt<100) {
				alt = ((alt/10).toFixed(0)) * 10;
			} else if (alt<1000) {
				alt = ((alt/50).toFixed(0)) * 50;
			} else {
				alt = ((alt/100).toFixed(0)) * 100;
			};
		} else {
			alt = "";
			this.vspeed = "";
		};
		
		if (SimVar.GetSimVarValue("SIM ON GROUND", "bool")==1) {
			if (this.state=="flying") {
				this.state = "landed";
				this.landLat = SimVar.GetSimVarValue("GPS POSITION LAT", "degrees");
				this.landLon = SimVar.GetSimVarValue("GPS POSITION LON", "degrees");
			}			
		} else {
			if (this.state=="stopped") {this.state = "flying"};
		};
		
		switch (this.state) {
			case "flying":
				if (alt!="") {
					this.lmode.innerHTML = "A<br>G<br>L<br>";
					this.vspeed = SimVar.GetSimVarValue("VERTICAL SPEED", "feet per second").toFixed(0) * 100;
					if (this.vspeed>0) {this.vspeed = ""};
				};
				break;
			case "landed":
				let lat = SimVar.GetSimVarValue("GPS POSITION LAT", "degrees");
				let lon = SimVar.GetSimVarValue("GPS POSITION LON", "degrees");
				this.dist = distance(this.landLat,this.landLon,lat,lon,"F").toFixed(0);
				if (this.dist>9999) {this.dist = "----"};
				if (SimVar.GetSimVarValue("GPS GROUND SPEED", "meters per second")<0.1) {
					this.state = "stopped";
				};
				this.lmode.innerHTML = "D<br>I<br>S<br>T";
				alt = this.dist;
				break;
			case "stopped":
				alt = this.dist;
				break;
		};

        this.lvalu.innerHTML = alt;
        this.rvalu.innerHTML = this.vspeed;
    }
}
registerInstrument("hour-meter-element", HourMeter);
//# sourceMappingURL=HourMeter.js.map