function distance(lat1, lon1, lat2, lon2, unit) {
	if ((lat1 == lat2) && (lon1 == lon2)) {
		return 0;
	} else {
		var radlat1 = Math.PI * lat1/180;
		var radlat2 = Math.PI * lat2/180;
		var theta = lon1-lon2;
		var radtheta = Math.PI * theta/180;
		var dist = Math.sin(radlat1) * Math.sin(radlat2) + Math.cos(radlat1) * Math.cos(radlat2) * Math.cos(radtheta);
		if (dist > 1) {dist = 1};
		dist = Math.acos(dist);
		dist = dist * 180/Math.PI;
		dist = dist * 60 * 1.1515; 					// miles (def)
		if (unit=="K") { dist = dist * 1.609344 } 	// km
		if (unit=="F") { dist = dist * 5280 }		// feet
		return dist;
	}
}

class HourMeter extends BaseInstrument {
    constructor() {
        super();
		
		this.useautopilot = true;  // change this to 'false' to disable AP functionality
		
		this.state = "flying";
		this.vspeed = 0;
		this.landLat = 0;
		this.landLon = 0;
		this.landVspd = 0;
		this.startLat = 0;
		this.startLon = 0;
		this.planeHeight = 0;
		this.apalt = 0;
		this.dist = 0;
		this.bear = 0;
		this.apon = (SimVar.GetSimVarValue("AUTOPILOT MASTER", "bool")==1);
    }
    get templateID() { return "HourMeter" }
	
    connectedCallback() {
        super.connectedCallback();
        this.lmode = this.getChildById("Lmode");
        this.lvalu = this.getChildById("Lvalu");
        this.lunit = this.getChildById("Lunit");

        this.rmode = this.getChildById("Rmode");
        this.rvalu = this.getChildById("Rvalu");
        this.runit = this.getChildById("Runit");

        //this.apstat = this.getChildById("GPSonoff");
        //this.apbear = this.getChildById("GPSbear");
        //this.apdist = this.getChildById("GPSdist");

		this.lunit.innerHTML = "ft";
		this.rmode.innerHTML = "V<br>S<br>P<br>D";
		this.runit.innerHTML = "ft/min";

        //this.apbear.addEventListener("click", this.bear++); // "wheel"
	
		if (typeof g_modDebugMgr != "undefined") {g_modDebugMgr.AddConsole(null)}; // if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};if (g_modDebugMgr) {g_modDebugMgr.AddConsole(null)};
    }
    disconnectedCallback() {
        super.disconnectedCallback();
    }
    Update() {
        super.Update();

		let alt = SimVar.GetSimVarValue("INDICATED ALTITUDE", "feet");
		let agl = SimVar.GetSimVarValue("PLANE ALT ABOVE GROUND", "feet").toFixed(0);;
		let vspd = SimVar.GetSimVarValue("VERTICAL SPEED", "feet per minute").toFixed(0);
		let lval = "";
		let rval = "";
		let currLat = SimVar.GetSimVarValue("GPS POSITION LAT", "degrees");
		let currLon = SimVar.GetSimVarValue("GPS POSITION LON", "degrees");
		let speed = SimVar.GetSimVarValue("GPS GROUND SPEED", "meters per second");

		if (SimVar.GetSimVarValue("SIM ON GROUND", "bool")==1) {
			if ((this.state=="flying") || (this.state=="takenoff")) {
				this.state = "landed";
				this.landLat = currLat;
				this.landLon = currLon;
				this.landVspd = vspd;
			}			
		} else {
			if (agl>100) {this.state = "flying"};
		};
		
		switch (this.state) {
			case "flying":
				this.lunit.innerHTML = "ft";
				this.runit.innerHTML = "ft/min";
				this.lmode.innerHTML = "A<br>G<br>L<br>";
				this.rmode.innerHTML = "V<br>S<br>P<br>D";
				
				let wpdist = SimVar.GetSimVarValue("GPS WP DISTANCE", "miles");
				let wpbear = SimVar.GetSimVarValue("GPS WP BEARING", "degrees");

				if (wpdist!=0) {
					SimVar.SetSimVarValue("K:HEADING_BUG_SET", "number",wpbear);
				};
				
				let showwp = false;
				if ((SimVar.GetSimVarValue("FLAPS HANDLE INDEX","number")==0) && (agl>1000) && (wpdist!=0)) {
					if ((SimVar.GetSimVarValue("AUTOPILOT MASTER", "bool")==1) && (this.useautopilot)) {
						if (!this.apon) {
							this.apon = true;

							this.apalt = (alt/100).toFixed(0) * 100;
							SimVar.SetSimVarValue("K:ALTITUDE_SLOT_INDEX_SET", "number", 1);
							Coherent.call("AP_ALT_VAR_SET_ENGLISH",1,this.apalt,true);
							
							//SimVar.SetSimVarValue("K:AP_PANEL_ALTITUDE_SET","feet",this.apalt); // fixed height, no physics
							//SimVar.SetSimVarValue("K:AP_ALT_HOLD_ON", "number",1);
							//SimVar.SetSimVarValue("K:FREEZE_ALTITUDE_TOGGLE", "number",1);
							//SimVar.SetSimVarValue("K:AP_PANEL_ALTITUDE_HOLD", "Number", 1);

							SimVar.SetSimVarValue("K:VS_SLOT_INDEX_SET", "number", 1);
							SimVar.SetSimVarValue("K:AP_PANEL_VS_ON", "Number", 1);

							if (wpdist!=0) {
								SimVar.SetSimVarValue("K:AP_NAV1_HOLD_ON", "number",1);
								if (SimVar.GetSimVarValue("GPS DRIVES NAV1", "bool")==0) {
									SimVar.SetSimVarValue("K:TOGGLE_GPS_DRIVES_NAV1", "number",1);
								};
							} else {
								this.bear = SimVar.GetSimVarValue("HEADING INDICATOR", "degrees");
								SimVar.SetSimVarValue("K:HEADING_BUG_SET", "number",this.bear);
								SimVar.SetSimVarValue("K:AP_PANEL_HEADING_HOLD", "number",1);
								lval = this.bear.toFixed(0) + "&deg; @ " + alt.toFixed(0) + " ft";
							};
						};
						this.lvalu.style.color = "aqua";
						this.lunit.innerHTML = "";
						this.runit.innerHTML = "";
						this.lmode.innerHTML = "B<br>E<br>A<br>R";
						this.rmode.innerHTML = "";

					} else {
						if (this.apon) {
							this.lunit.innerHTML = "";
							this.apon = false;
							SimVar.SetSimVarValue("K:AXIS_ELEV_TRIM_SET","number",0);
							if (wpdist==0) {
								lval = "";
								rval = "";
							};
						};
						this.lvalu.style.color = "yellow";
						this.lunit.innerHTML = "ft";
						this.runit.innerHTML = "ft/min";
						this.lmode.innerHTML = "A<br>G<br>L<br>";
						this.rmode.innerHTML = "V<br>S<br>P<br>D";
					};

					if (wpdist!=0) {
						SimVar.SetSimVarValue("K:HEADING_BUG_SET", "number",wpbear);
						let compass = SimVar.GetSimVarValue("HEADING INDICATOR", "degrees");
						let diff = wpbear - compass;
						if (diff<-180) {diff += 360};
						lval = wpbear.toFixed(0) + "&deg;";
						rval = wpdist.toFixed(1) ;
						this.lunit.innerHTML = SimVar.GetSimVarValue("GPS WP NEXT ID", "string");
						this.runit.innerHTML = "miles";
						this.lmode.innerHTML = "B<br>E<br>A<br>R";
						this.rmode.innerHTML = "D<br>I<br>S<br>T";
						showwp = true;
					};
				}
				if ((!showwp) && (agl<2000)) {
					lval = agl;
					rval = ((vspd/50).toFixed(0))*50;
					if (lval<100) {
						lval = ((lval/10).toFixed(0)) * 10;
					} else if (lval<1000) {
						lval = ((lval/50).toFixed(0)) * 50;
					} else if (lval<1950) {
						lval = ((lval/100).toFixed(0)) * 100;
					};
					this.lvalu.style.color = "yellow";
					this.lunit.innerHTML = "ft";
					this.runit.innerHTML = "ft/min";
					this.lmode.innerHTML = "A<br>G<br>L<br>";
					this.rmode.innerHTML = "V<br>S<br>P<br>D";
				};
				break;
			case "landed":
				this.dist = distance(this.landLat,this.landLon,currLat,currLon,"F").toFixed(0);
				if (this.dist>9999) {this.dist = "----"};
				if (speed<0.1) {
					this.state = "stopped";
				};
				this.lmode.innerHTML = "D<br>I<br>S<br>T";
				lval = this.dist;
				rval = this.landVspd;
				break;
			case "stopped":
				if ((speed>1) && (SimVar.GetSimVarValue("GENERAL ENG THROTTLE LEVER POSITION:1","percent")>50)) {
					this.startLat = currLat;
					this.startLon = currLon;
					this.state = "takeoff";
					this.planeHeight = agl;
				};
				lval = this.dist;
				rval = this.landVspd;
				break;
			case "takeoff":
				if ((agl-this.planeHeight)>1) {
					//this.state = "takenoff";
				} else {
					this.dist = distance(this.startLat,this.startLon,currLat,currLon,"F").toFixed(0);
					if (this.dist>9999) {this.dist = "----"};
				};
				lval = this.dist;
				rval = ((vspd/50).toFixed(0))*50;
				if (speed<0.1) {
					this.state = "stopped";
				};
				break;
		};

        this.lvalu.innerHTML = lval;
        this.rvalu.innerHTML = rval;
    }
}
registerInstrument("hour-meter-element", HourMeter);
//# sourceMappingURL=HourMeter.js.map